PingOne Platform APIs - Early Access

Roll Back a Promotion

POST {{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}

Use POST /environments/{environmentId}/promotions/{promotionID} with the Content-Type set to application/vnd.pingidentity.promotion.rollback+json. This creates a rollback of all promoted resources. Once executed, the promotion status is updated to ROLLED_BACK.

A rollback operation creates a new promotion that reverts the changes of the original promotion. When the new promotion for the rollback is executed, its status is updated to COMPLETED, and the status of the original promotion is updated to ROLLED_BACK.

The promotion for the rollback contains the resources that were rolled back, and the details of the rollback operation. You can use Read One Promotion or Read All Promotions to view the promotion for the rollback.

These limitations are enforced:

  • Only the last-executed promotion (in COMPLETED or ERROR status) can be rolled back. You can’t roll back a promotion from the middle of the promotions list, or a promotion that hasn’t been executed yet.

  • You can only rollback a promotion if it was not already rolled back.

Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/vnd.pingidentity.promotion.rollback+json

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff --request POST '{{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}' \
--header 'Content-Type: application/vnd.pingidentity.promotion.rollback+json' \
--header 'Authorization: Bearer {{accessToken}}'
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/vnd.pingidentity.promotion.rollback+json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}"
  method := "POST"

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, nil)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/vnd.pingidentity.promotion.rollback+json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /v1/environments/{{envId}}/promotions/{{promotionID}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/vnd.pingidentity.promotion.rollback+json
Authorization: Bearer {{accessToken}}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/vnd.pingidentity.promotion.rollback+json");
RequestBody body = RequestBody.create(mediaType, "");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}")
  .method("POST", body)
  .addHeader("Content-Type", "application/vnd.pingidentity.promotion.rollback+json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/vnd.pingidentity.promotion.rollback+json",
    "Authorization": "Bearer {{accessToken}}"
  },
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}',
  'headers': {
    'Content-Type': 'application/vnd.pingidentity.promotion.rollback+json',
    'Authorization': 'Bearer {{accessToken}}'
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}"

payload = {}
headers = {
  'Content-Type': 'application/vnd.pingidentity.promotion.rollback+json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/vnd.pingidentity.promotion.rollback+json',
  'Authorization' => 'Bearer {{accessToken}}'
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/vnd.pingidentity.promotion.rollback+json"
request["Authorization"] = "Bearer {{accessToken}}"

response = http.request(request)
puts response.read_body
var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envId}}/promotions/{{promotionID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/vnd.pingidentity.promotion.rollback+json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

202 Accepted

{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/promotions/9fbd3b5e-8365-4fa3-9d52-2a862ae155ae"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "targetEnvironment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "sourceSnapshot": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/snapshots/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/versions/d98c98d9-50f1-4774-9c92-c47f7522d657"
        },
        "targetSnapshot": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/snapshots/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/versions/0d7d8c3a-5232-4f5c-974c-c2824be57259"
        },
        "previousPromotion": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/promotions/5d2105ef-2657-4920-93ff-1328f86d51ab"
        },
        "promotionSteps": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/promotions/9fbd3b5e-8365-4fa3-9d52-2a862ae155ae/promotionSteps"
        }
    },
    "id": "9fbd3b5e-8365-4fa3-9d52-2a862ae155ae",
    "createdAt": "2026-05-25T17:58:42.627Z",
    "updatedAt": "2026-05-25T17:58:42.627Z",
    "sourceEnvironmentId": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6",
    "sourceEnvironment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "targetEnvironmentId": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6",
    "targetEnvironment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "sourceSnapshotId": "d98c98d9-50f1-4774-9c92-c47f7522d657",
    "sourceSnapshot": {
        "id": "d98c98d9-50f1-4774-9c92-c47f7522d657"
    },
    "targetSnapshotId": "0d7d8c3a-5232-4f5c-974c-c2824be57259",
    "targetSnapshot": {
        "id": "0d7d8c3a-5232-4f5c-974c-c2824be57259"
    },
    "previousPromotion": {
        "id": "5d2105ef-2657-4920-93ff-1328f86d51ab"
    },
    "status": "ROLLBACK_NEW",
    "resourceMapping": {},
    "description": "Rolling back promotion."
}